% KNN ALGORITHM (find nn nearest neighbors)
%
% [neighborhood] = knn(XX,nn)
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [neighborhood] = knn(XX,nn)

[DD NN] = size(XX);

oneNN = ones(NN,1);
onenn = ones(nn,1);

% STEP 1: COMPUTE PAIRWISE DISTANCES & FIND NEIGHBORS 

tic
if NN*NN*8<100e6, % makes sure we don't run out of memory.
  X2 = sum(XX.^2,1);
  distance = X2(oneNN,:);
  distance = distance + distance' - 2*XX'*XX;

  [sorted,index] = sort(distance);
  neighborhood = index(2:(1+nn),:);
else
  neighborhood = zeros(nn,NN);
  X2 = sum(XX.^2,1);
  for ni=1:NN,
    distance = X2(ni) + X2 - 2*XX(:,ni)'*XX;
    [sorted,index] = sort(distance);
    neighborhood(:,ni) = index(2:(1+nn))';
    if rem(ni,100)==0, fprintf(1,'ii%d time%f\r',ni,toc); end;
  end;
end;
fprintf(1,'   [time %f]            \n',toc);

