
function [lik] = likmfa(XX,LX,MX,PX,Pi);

[DD FF KK] = size(LX);
NN    = size(XX,2);
oneNN = ones(1,NN);
oneKK = ones(1,KK);
oneFF = ones(1,FF);
eyeFF = eye(FF);

const = -DD/2*log(2*pi);
rr  = zeros(KK,NN);

  % E step
  pi = 1./PX;
  for kk=1:KK,
    l        = LX(:,:,kk);
    ltpi     = (pi(:,oneFF).*l)';
    ltpil    = ltpi*l;
    iltpil   = eyeFF + ltpil;
    cc       = chol(iltpil);
    cci      = inv(cc);
    covz     = cci*cci';
    delta    = XX-MX(:,kk*oneNN);
    meanz    = ((eyeFF-ltpil*covz)*ltpi)*delta;

    rr(kk,:)    = -.5*(pi'*(delta.*delta) - sum(meanz.*(iltpil*meanz),1)) - ...
                  sum(log(diag(cc)));
  end;

  rr = rr + const + .5*sum(log(pi));
  mm = max(rr,[],1);
  rr = exp(rr-mm(oneKK,:));
  ss = sum(rr,1);

  lik = mm+log(ss);

