function llcviewer(dims,imsize,XX,LX,MX,PX,Pi,YY,LY,MY,snap);

PY = 1e-3*ones(size(MY,1),1);

% set up interactive window and axes
ff = figure(1);
set(ff,'position',[720 50 550 550],'menubar','none','toolbar','figure');
clf
fullfig;
aa = gca;
plot(YY(dims(1),:),YY(dims(2),:),'.');
hold on;
plotmfa2(LY(dims,:,:),MY(dims,:),PY(dims,1),{'k-'},[]);
Vinit(ff,aa);

% set up window and axes for printing
f1 = figure(2);
set(f1,'menubar','none','toolbar','none',...
         'doublebuffer','on','position',[10 160 700 90]);
colormap gray; clf;

f2 = figure(3);
set(f2,'menubar','none','toolbar','none',...
         'doublebuffer','on','position',[10 50 700 90]);
colormap gray; clf;

% set up window and axes for viewing.
f3 = figure(4);
set(f3,'menubar','none','toolbar','none',...
         'doublebuffer','on','position',[500 270 200 100]);
colormap gray; clf;

%%%%%%%%%%%%%%%%%%%%%% LLC
P.XX = XX;
P.YY = YY;
P.Pi = Pi;
P.MX = MX;
P.PX = PX;
P.LX = LX;
P.MY = MY;
P.LY = LY;
P.PY = PY;

P.snap  = snap;
P.dims  = dims;
P.idims = 1:3;

P.imsize = imsize;
P.numim = 20;
P.numrep = 3;
P.montage = 1;
P.crange = [.1 .9];


% LLC motion viewer
figure(ff);
P.hf = plot(0,0,'ro','linewidth',2);

figure(f3);
subplot('position',[0 0 .5 1]);
xx = y2x([0;0],P.LX,P.MX,P.PX,P.Pi,P.LY(dims,:,:),P.MY(dims,:),P.PY(dims,1));
P.hv = hinton(xx,P.imsize,P.crange);
set(P.hv,'EraseMode','none');
Vmotionviewer(ff,aa,'llcmotionviewer',P);


% llc montage line viewer
figure(ff);
P.hf = plot([0 0],[0 0],'r-','linewidth',2);
figure(f1);
clf; fullfig;
xx = y2x([0;0],P.LX,P.MX,P.PX,P.Pi,P.LY(dims,:,:),P.MY(dims,:),P.PY(dims,1));
P.hv = hinton(xx(:,ones(1,P.numim)),[P.imsize 1 P.numim],P.crange);
ylabel('LLC');
set(P.hv,'EraseMode','none');
Vlineviewer(ff,aa,'llclineprinter',P);

clear P



%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LLE
P.XX = XX;
P.YY = YY;

P.snap = 1;
P.dims = dims;
P.idims = 1:2;

P.imsize = imsize;
P.crange = [0 1];
P.numim  = 20;
P.montage = 1;

% motion viewer
figure(ff);
P.hf = plot(0,0,'cx','linewidth',2);
figure(f3);
subplot('position',[.5 0 .5 1]);
xx = lley2x(P.XX,P.YY(dims,:),[0;0]);
P.hv = hinton(xx,P.imsize,P.crange);
set(P.hv,'EraseMode','none');
Vmotionviewer(ff,aa,'llemotionviewer',P);


% line viewer
figure(ff);
P.hf = plot(zeros(1,P.numim),zeros(1,P.numim),'cx','linewidth',2);
figure(f2);
clf; fullfig;
xx = zeros(size(XX,1),P.numim);
P.hv = hinton(xx,[P.imsize 1 P.numim],P.crange);
ylabel('LLE');
set(P.hv,'EraseMode','none');
Vlineviewer(ff,aa,'llelineprinter',P);

clear P
