function llcviewer(dims,imsize,XX,LX,MX,PX,Pi,YY,LY,MY,snap);

PY = 1e-3*ones(size(MY,1),1);

% set up interactive window and axes
ff = figure(2);
set(ff,'position',[10 230 430 430],'menubar','none','toolbar','figure');
clf
fullfig;
aa = gca;
plot(YY(dims(1),:),YY(dims(2),:),'.');
hold on;
plotmfa2(LY(dims,:,:),MY(dims,:),PY(dims,1),{'k-'},[]);
set(ff,'doublebuffer','on');
Vinit(ff,aa);

% set up window and axes for viewers
f1 = figure(1);
set(f1,'menubar','none','toolbar','none',...
         'doublebuffer','on','position',[10 50 780 160]);
colormap gray; clf;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LLE
P.XX = XX;
P.YY = YY;

P.snap = 1;
P.dims = dims;
P.idims = dims;

P.imsize = imsize;
P.crange = [0 1];
P.numim  = 20;
P.montage = 1;

% motion viewer
figure(ff);
P.hf = plot(0,0,'cx','linewidth',2);
figure(f1);
subplot('position',[.8 .5 .1 .5]);
xx = lley2x(P.XX,P.YY(dims,:),[0;0]);
P.hv = hinton(xx,P.imsize,P.crange);
set(P.hv,'EraseMode','none');
Vmotionviewer(ff,aa,'llemotionviewer',P);


% line viewer
figure(ff);
P.hf = plot(zeros(1,P.numim),zeros(1,P.numim),'cx','linewidth',2);
figure(f1);
subplot('position',[.0 .5 .8 .5]);
xx = zeros(size(XX,1),P.numim);
P.hv = hinton(xx,[P.imsize 1 P.numim],P.crange);
title('LLEmbedding','position',[200 0 0]);
set(P.hv,'EraseMode','none');
Vlineviewer(ff,aa,'llelineviewer',P);

clear P


%%%%%%%%%%%%%%%%%%%%%% LLC
P.XX = XX;
P.YY = YY;
P.Pi = Pi;
P.MX = MX;
P.PX = PX;
P.LX = LX;
P.MY = MY;
P.LY = LY;
P.PY = PY;

P.snap  = snap;
P.dims  = dims;
P.idims = 1:4;

P.imsize = imsize;
P.numim = 20;
P.numrep = 3;
P.montage = 1;
P.crange = [0 1];


% llc motion viewer
figure(ff);
P.hf = plot(0,0,'ro','linewidth',2);

figure(f1);
subplot('position',[.8 .0 .1 .5]);
xx = y2x([0;0],P.LX,P.MX,P.PX,P.Pi,P.LY(dims,:,:),P.MY(dims,:),P.PY(dims,1));
P.hv = hinton(xx,P.imsize,P.crange);
set(P.hv,'EraseMode','none');
Vmotionviewer(ff,aa,'llcmotionviewer',P);

% llc montage line viewer
figure(ff);
P.hf = plot([0 0],[0 0],'r-','linewidth',2);
figure(f1);
subplot('position',[.0 .0 .8 .5]);
xx = y2x([0;0],P.LX,P.MX,P.PX,P.Pi,P.LY(dims,:,:),P.MY(dims,:),P.PY(dims,1));
P.hv = hinton(xx(:,ones(1,P.numim)),[P.imsize 1 P.numim],P.crange);
title('LLCoordination','position',[200 0 0]);
set(P.hv,'EraseMode','none');
Vlineviewer(ff,aa,'llclineviewer',P);

% llc movie line viewer
P.montage = 0;
P.delay = .02;
figure(ff);
P.hf = plot(0,0,'ro','linewidth',2);

figure(f1);
subplot('position',[.9 .0 .1 .5]);
xx = y2x([0;0],P.LX,P.MX,P.PX,P.Pi,P.LY(dims,:,:),P.MY(dims,:),P.PY(dims,1));
P.hv = hinton(xx,P.imsize,P.crange);
set(P.hv,'EraseMode','none');
Vlineviewer(ff,aa,'llclineviewer',P);


clear P




