function [d2,proj] = projline(p1,p2,xx)
% [d2,proj] = projline(p1,p2,xx)
%
% computes the squared distances d2 of each point in xx
% to the line between p1 and p2; also computes the normalized
% projection onto p1-p2 using p1=0, p2=1
%
% in all cases, points are column vectors

pdiff = p2(:)-p1(:);
uu = pdiff/sqrt(pdiff'*pdiff);
proj=uu'*xx-p1(:)'*uu;
d2 = sum(xx.*xx,1)-2*p1(:)'*xx+p1(:)'*p1(:)-proj.^2;
proj=proj./((p2(:)-p1(:))'*uu);

