% YY = x2y(XX,LX,MX,PX,Pi,LY,MY);
%
%   Computes YY from XX given parameters of LLC embedding.
%

function YY = x2y(XX,LX,MX,PX,Pi,LY,MY);

[dd FF KK] = size(LY);
NN = size(XX,2);
kf = KK*(FF+1);
oneFF = ones(1,FF+1);

LY(:,end+1,:) = reshape(MY,[dd 1 KK]);
LY = reshape(permute(LY,[3 2 1]),[kf dd]);

[RR,ZZ] = infermfa(XX,LX,MX,PX,Pi);

RR = reshape(RR,[1 KK NN]);
ZZ(end+1,:,:) = 1;
ZZ = permute(ZZ,[1 3 2]);
UU = reshape(permute(RR(oneFF,:,:).*ZZ,[3 2 1]),[NN kf]);

YY = (UU*LY)';

