function ii = xknn(XX,YY,nn);

% ii = XKNN(XX,YY,nn) - Cross k-nn 
%   For each column in YY find nn closest columns in XX.
%   Returns the indices of the closest columns.

[dd NN] = size(XX);
MM = size(YY,2);

oneNN = ones(1,NN);

ii = zeros(nn,MM);

for mm=1:MM,
  dist = sum((XX - YY(:,mm*oneNN)).^2,1);
  [dist ind] = sort(dist);
  ii(:,mm) = ind(1:nn)';
end;

